package ru.vyatsu.qr_access_api.repository

import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.autoconfigure.jdbc.JdbcTest
import org.springframework.boot.test.context.TestConfiguration
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Import
import org.springframework.jdbc.core.JdbcTemplate
import ru.vyatsu.qr_access_api.database.utils.InsertDatabaseHelper

@JdbcTest
@Import(RepositoryTest.Configuration::class)
class RepositoryTest {

    @Autowired
    protected lateinit var insertDatabaseHelper: InsertDatabaseHelper

    @Autowired
    protected lateinit var qrRepository: QrRepository

    @TestConfiguration
    class Configuration {

        @Autowired
        private lateinit var template: JdbcTemplate

        @Bean
        fun qrRepository(): QrRepository {
            return QrRepository(template)
        }

        @Bean
        fun dbUtils(): InsertDatabaseHelper {
            return InsertDatabaseHelper(template)
        }
    }
}